/* Problem URL: https://codeforces.com/gym/104020/problem/L?mobile=false */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 0

struct point {
    ll x;
    ll y;
    ll z;

    friend istream &operator>>(istream &is, point &a) {
        is >> a.x >> a.y >> a.z;
        return is;
    }

    bool operator<(point b) const {
        if (x == b.x) {
            if (y == b.y) {
                return z < b.z;
            }

            return y < b.y;
        }

        return x < b.x;
    }
};

ll sqr(ll x)
{
    return x * x;
}

long double dis(point a, point b)
{
    ll x = a.x - b.x;
    ll y = a.y - b.y;
    ll z = a.z - b.z;
    return sqrtl(sqr(x) + sqr(y) + sqr(z));
}

void solve()
{
    int n;
    cin >> n;

    V<point> p(n);
    cin >> p;

    sortv(p);

    long double ans = 1e16;

    struct compy {
        bool operator()(point a, point b) const {
            if (a.y == b.y) {
                if (a.z == b.z) {
                    return a.x > b.x;
                }

                return a.z > b.z;
            }

            return a.y > b.y;
        }
    };

    struct compz {
        bool operator()(point a, point b) const {
            if (a.z == b.z) {
                if (a.x == b.x) {
                    return a.y > b.y;
                }

                return a.x > b.x;
            }

            return a.z > b.z;
        }
    };

    set<point, compy> sy;
    set<point, compz> sz;

    sy.emplace(p[0]);
    sz.emplace(p[0]);

    int cur = 0;

    nrep(i, 1, n) {
        while (p[cur].x < p[i].x -  ans) {
            sy.erase(p[cur]);
            sz.erase(p[cur]);
            cur++;
        }

        auto itr = sy.lower_bound(point(1e9, p[i].y + ans, 1e9));
        while (itr != sy.end() && abs(p[i].y - itr->y) <= ans) {
            rmin(ans, dis(p[i], *itr));
            itr++;
        }

        itr = sz.lower_bound(point(1e9, 1e9, p[i].z + ans));
        while (itr != sz.end() && abs(p[i].z - itr->z) <= ans) {
            rmin(ans, dis(p[i], *itr));
            itr++;
        }

        sy.emplace(p[i]);
        sz.emplace(p[i]);
    }

    cout << fixed << setprecision(7) << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
